searchNodes=[{"doc":"Interface with Hashicorp's vault.","ref":"Vaultex.html","title":"Vaultex","type":"module"},{"doc":"Callback implementation for Application.start/2.","ref":"Vaultex.html#start/2","title":"Vaultex.start/2","type":"function"},{"doc":"","ref":"Vaultex.Auth.html","title":"Vaultex.Auth","type":"module"},{"doc":"","ref":"Vaultex.Auth.html#handle/3","title":"Vaultex.Auth.handle/3","type":"function"},{"doc":"Helper functions for AWS IAM instance metadata role authentication","ref":"Vaultex.Auth.AWSIAM.html","title":"Vaultex.Auth.AWSIAM","type":"module"},{"doc":"","ref":"Vaultex.Auth.AWSIAM.html#credentials/2","title":"Vaultex.Auth.AWSIAM.credentials/2","type":"function"},{"doc":"Provides a functionality to authenticate and read from a vault endpoint.","ref":"Vaultex.Client.html","title":"Vaultex.Client","type":"module"},{"doc":"Authenticates with vault using a tuple. This can be executed before attempting to read secrets from vault.Parametersmethod: Auth backend to use for authenticating, can be one of :approle, :app_id, :userpass, :github, :tokencredentials: A tuple or map used for authentication depending on the method, {role_id, secret_id} for :approle, {app_id, user_id} for :app_id, {username, password} for :userpass, {github_token} for :github, {token} for :token, or json-encodable map for unhandled methods, i.e. %{jwt: &quot;jwt&quot;, role: &quot;role&quot;} for :kubernetestimeout: A integer greater than zero which specifies how many milliseconds to wait for a replyExamplesiex&gt; Vaultex.Client.auth(:approle, {role_id, secret_id}, 5000) {:ok, :authenticated} iex&gt; Vaultex.Client.auth(:app_id, {app_id, user_id}) {:ok, :authenticated} iex&gt; Vaultex.Client.auth(:userpass, {username, password}) {:error, [&quot;Something didn&#39;t work&quot;]} iex&gt; Vaultex.Client.auth(:github, {github_token}) {:ok, :authenticated} iex&gt; Vaultex.Client.auth(:jwt, %{jwt: jwt, role: role}) {:ok, :authenticated}","ref":"Vaultex.Client.html#auth/3","title":"Vaultex.Client.auth/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Vaultex.Client.html#child_spec/1","title":"Vaultex.Client.child_spec/1","type":"function"},{"doc":"Deletes a secret in Vault given a path.Parameterskey: A String path where the secret will be deleted.auth_method and credentials: See Vaultex.Client.authtimeout: A integer greater than zero which specifies how many milliseconds to wait for a replyExamplesiex&gt; Vaultex.Client.delete(&quot;secret/foo&quot;, :app_role, {role_id, secret_id}, 5000) :ok iex&gt; Vaultex.Client.delete(&quot;secret/foo&quot;, :app_id, {app_id, user_id}) :ok","ref":"Vaultex.Client.html#delete/4","title":"Vaultex.Client.delete/4","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Vaultex.Client.html#init/1","title":"Vaultex.Client.init/1","type":"function"},{"doc":"Reads a secret from vault given a path.Parameterskey: A String path to be used for querying vault.auth_method and credentials: See Vaultex.Client.authtimeout: A integer greater than zero which specifies how many milliseconds to wait for a replyExamplesiex&gt; Vaultex.Client.read(&quot;secret/foobar&quot;, :approle, {role_id, secret_id}, 5000) {:ok, %{&quot;value&quot; =&gt; &quot;bar&quot;}} iex&gt; Vaultex.Client.read(&quot;secret/foo&quot;, :app_id, {app_id, user_id}) {:ok, %{&quot;value&quot; =&gt; &quot;bar&quot;}} iex&gt; Vaultex.Client.read(&quot;secret/baz&quot;, :userpass, {username, password}) {:error, [&quot;Key not found&quot;]} iex&gt; Vaultex.Client.read(&quot;secret/bar&quot;, :github, {github_token}) {:ok, %{&quot;value&quot; =&gt; &quot;bar&quot;}} iex&gt; Vaultex.Client.read(&quot;secret/bar&quot;, :plugin_defined_auth, credentials) {:ok, %{&quot;value&quot; =&gt; &quot;bar&quot;}}","ref":"Vaultex.Client.html#read/4","title":"Vaultex.Client.read/4","type":"function"},{"doc":"Reads a dynamic secret from vault given a path and returns the secret along with lease information.Parameterskey: A String path to be used for querying vault.auth_method and credentials: See Vaultex.Client.authtimeout: A integer greater than zero which specifies how many milliseconds to wait for a replyExamplesiex&gt; Vaultex.Client.read_dynamic(&quot;secret/dynamic/foobar&quot;, :approle, {role_id, secret_id}, 5000) {:ok, %{&quot;data&quot; =&gt; %{&quot;value&quot; =&gt; &quot;bar&quot;}, &quot;lease_duration&quot; =&gt; 60, &quot;lease_id&quot; =&gt; &quot;secret/dynamic/foo/b4z&quot;, &quot;renewable&quot; =&gt; true}} iex&gt; Vaultex.Client.read_dynamic(&quot;secret/dynamic/foo&quot;, :app_id, {app_id, user_id}) {:ok, %{&quot;data&quot; =&gt; %{&quot;value&quot; =&gt; &quot;bar&quot;}, &quot;lease_duration&quot; =&gt; 60, &quot;lease_id&quot; =&gt; &quot;secret/dynamic/foo/b4z&quot;, &quot;renewable&quot; =&gt; true}} iex&gt; Vaultex.Client.read_dynamic(&quot;secret/dynamic/baz&quot;, :userpass, {username, password}) {:error, [&quot;Key not found&quot;]} iex&gt; Vaultex.Client.read_dynamic(&quot;secret/dynamic/bar&quot;, :github, {github_token}) {:ok, %{&quot;data&quot; =&gt; %{&quot;value&quot; =&gt; &quot;bar&quot;}, &quot;lease_duration&quot; =&gt; 60, &quot;lease_id&quot; =&gt; &quot;secret/dynamic/foo/b4z&quot;, &quot;renewable&quot; =&gt; true}} iex&gt; Vaultex.Client.read_dynamic(&quot;secret/dynamic/bar&quot;, :plugin_defined_auth, credentials) {:ok, %{&quot;data&quot; =&gt; %{&quot;value&quot; =&gt; &quot;bar&quot;}, &quot;lease_duration&quot; =&gt; 60, &quot;lease_id&quot; =&gt; &quot;secret/dynamic/foo/b4z&quot;, &quot;renewable&quot; =&gt; true}}","ref":"Vaultex.Client.html#read_dynamic/4","title":"Vaultex.Client.read_dynamic/4","type":"function"},{"doc":"Renews a lease for a dynamic secretParameterslease_id: A String that is the lease ID returned when reading a dynamic secretincrement: An Integer that represents the time in seconds to extend the lease byauth_method and credentials: See Vaultex.Client.authtimeout: A integer greater than zero which specifies how many milliseconds to wait for a replyExamplesiex&gt; Vaultex.Client.renew_lease(&quot;secret/dynamic/foo/b4z&quot;, 100, :app_role, {role_id, secret_id}, 5000) {:ok, %{&quot;lease_id&quot; =&gt; &quot;secret/dynamic/foo/b4z&quot;, &quot;lease_duration&quot; =&gt; 160, &quot;renewable&quot; =&gt; true}}","ref":"Vaultex.Client.html#renew_lease/5","title":"Vaultex.Client.renew_lease/5","type":"function"},{"doc":"","ref":"Vaultex.Client.html#start_link/0","title":"Vaultex.Client.start_link/0","type":"function"},{"doc":"Writes a secret to Vault given a path.Parameterskey: A String path where the secret will be written.value: A String =&gt; String map that will be stored in Vaultauth_method and credentials: See Vaultex.Client.authtimeout: A integer greater than zero which specifies how many milliseconds to wait for a replyExamplesiex&gt; Vaultex.Client.write(&quot;secret/foo&quot;, %{&quot;value&quot; =&gt; &quot;bar&quot;}, :app_role, {role_id, secret_id}, 5000) :ok iex&gt; Vaultex.Client.write(&quot;secret/foo&quot;, %{&quot;value&quot; =&gt; &quot;bar&quot;}, :app_id, {app_id, user_id}) :ok","ref":"Vaultex.Client.html#write/5","title":"Vaultex.Client.write/5","type":"function"},{"doc":"","ref":"Vaultex.Delete.html","title":"Vaultex.Delete","type":"module"},{"doc":"","ref":"Vaultex.Delete.html#handle/2","title":"Vaultex.Delete.handle/2","type":"function"},{"doc":"","ref":"Vaultex.Leases.html","title":"Vaultex.Leases","type":"module"},{"doc":"","ref":"Vaultex.Leases.html#handle/4","title":"Vaultex.Leases.handle/4","type":"function"},{"doc":"","ref":"Vaultex.Read.html","title":"Vaultex.Read","type":"module"},{"doc":"","ref":"Vaultex.Read.html#handle/2","title":"Vaultex.Read.handle/2","type":"function"},{"doc":"","ref":"Vaultex.RedirectableRequests.html","title":"Vaultex.RedirectableRequests","type":"module"},{"doc":"","ref":"Vaultex.RedirectableRequests.html#request/5","title":"Vaultex.RedirectableRequests.request/5","type":"function"},{"doc":"","ref":"Vaultex.Test.TestDoubles.MockHTTPoison.html","title":"Vaultex.Test.TestDoubles.MockHTTPoison","type":"module"},{"doc":"","ref":"Vaultex.Test.TestDoubles.MockHTTPoison.html#request/5","title":"Vaultex.Test.TestDoubles.MockHTTPoison.request/5","type":"function"},{"doc":"","ref":"Vaultex.Write.html","title":"Vaultex.Write","type":"module"},{"doc":"","ref":"Vaultex.Write.html#handle/3","title":"Vaultex.Write.handle/3","type":"function"}]